/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER             "0.1"
#define BUFFSZ          4096
#define REM             "remember="
#define READSHOW(x,y)   \
        ptr = strchr(ptr1, ','); \
        if(ptr) { \
            if(y) { \
                ptr = strrchr(ptr1, ','); \
                if(ptr > ptr1) { \
                    *(ptr - 1) = 0; \
                    rpad_pwd(++ptr1); \
                } \
            } \
            *ptr = 0; \
            printf(x"%s\n", ptr1); \
            ptr1 = ptr + 1; \
        }



#ifndef WIN32
    #define strnicmp strncasecmp
#endif

#ifndef u_char
    #define u_char  unsigned char
#endif



void rpad_pwd(u_char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    u_char  buff[BUFFSZ + 1],
            *ptr,
            *ptr1;


    setbuf(stdout, NULL);

    fputs("\n"
        "RemotePad passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <remotepad.ini>\n"
            "\n", argv[0]);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    printf("\nOpening file %s\n\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    while(1) {
        if(!fgets(buff, BUFFSZ, fd)) break;

        if(strnicmp(buff, REM, sizeof(REM) - 1)) continue;

        ptr = ptr1 = buff + sizeof(REM) - 1;
        for(; *ptr > 0xd; ptr++);
        *ptr = 0;

        fputc('\n', stdout);
        READSHOW("Hostname:    ", 0);
        READSHOW("Username:    ", 0);
        READSHOW("Password:    ", 1);
        printf("Timeout:     %s\n", ptr1);
    }

    fclose(fd);
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void rpad_pwd(u_char *pwd) {
    u_char  al,
            *out;
    int     len = strlen(pwd);

    out = pwd;
    while(len--) {
        if((pwd[0] & pwd[1]) == '"') {  // ""
            pwd++;
            continue;
        }
        al = -*pwd;
        al += *++pwd;
        do {
            al += 0x5f;
        } while(al < 0x20);
        *out++ = al;
    }
    *(out - 1) = 0;
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


